/*     23/10/01    gcc-2.95.2
*---------------------------------------------------
*COME TROVARE LA FRAZ.GENERATRICE DI UN N.DECIMALE ?
*----------------------------------------------------
*Matematicamente, per i numeri con parte periodica, si segue la seguente regola:
*la frazione generatrice si ottiene mettendo a numeratore la differenza tra tutto il
*numero ed il numero costituito dalle cifre a sinistra di quelle con il periodo 
*ed al denominatore un numero costituito da tanti 9 quante sono le cifre del periodo 
*e tanti ZERI quante sono le cifre dell'antiperiodo. 
*Esempi:
*1) 5,34(567)=(534567 - 534)/99900 = 534033/99900
*2) 7,(5)=(75-7)/9=68/9
*------------------------
*LIMITI DEL PROGRAMMA
*------------------------
*Siccome non avevo voglia/tempo non c' controllo sull'input utente.
*Se la cifra non viene scritta correttamente il risultato  imprevedibile.
*Il software non esegue l'eventuale semplificazione della frazione.
*----------------------------------
*PROTOTIPI DI ALCUNE FUNZIONI USATE
*----------------------------------
*#include <string.h>
*size_t strcspn(const char *s1, const char *set);
*Description:
*This function finds the first character in S1 that matches any
*character in SET.  Note that the `NULL' bytes at the end of each string
*counts, so you'll at least get a pointer to the end of the string if
*nothing else.

*#include <string.h>
*char *strchr(const char *s, int c);
*Description:
*This function returns a pointer to the first occurrence of C in S.
*Note that if C is `NULL', this will return a pointer to the end of the
*string.

*#include <string.h>
*size_t strlen(const char *string);
*Description:
*This function returns the number of characters in STRING.

*#include <string.h>
*char *strcpy(char *s1, const char *s2);
*Description:
*This function copies S2 into S1.

*#include <string.h>
*char *strcat(char *s1, const char *s2);
*Description:
*This function concatenates S2 to the end of S1.

*#include <stdlib.h>
*long atol(const char *string);
*Description
*Convert as much of the string as possible to an equivalent long integer
*value.
*--------
* LINUX
*--------
*provato anche su Linux Mandrake v.8.0 
*sost. NULL con '\0'
*/
/* decl. library */
#include <stdio.h>
#include <string.h>
//unsigned _stklen=1048576; //1 Mb of stack (not need)
/* decl. function */
void main (void);
char *intero (char numero[]);
char *antiperiodo (char numero[]);
char *periodo (char numero[]);
long int denominatore (char antiper[],char period[]);
/* start code */
void main(void)
{
 char ins[20],tutto[20]="",sott[20]="";
 char integer[20],antiper[20],period[20];
 long int val_tutto,val_sott,val_denom;
 //char *pt_ins;
 //pt_ins=&ins[0];	//pt. al 1char inserito (not need)
 //clrscr(); (no su linux)
 printf("\nIns un n. usando il . come indicat.dec. e ( ) per la parte periodica");
 printf("\nEs.:  5.34(567)  5:intero  34:antiperiodo  567:periodo");
 printf("\n\nnumero ? ");
 fgets(ins, 20, stdin);	//max. 20 caratteri stdin (rev.1)
 ins[strlen(ins)-1]='\0';	//taglia ins sul return (rev.1)
 //*(pt_ins+(strlen(ins))-1)='\0';	(not need)
 strcpy(integer,intero(ins));
 strcpy(antiper,antiperiodo(ins));
 strcpy(period,periodo(ins));
 strcat(tutto,integer);strcat(tutto,antiper);strcat(tutto,period);
 strcat(sott,integer);strcat(sott,antiper);
 val_tutto=atol(tutto);
 val_sott=atol(sott);
 val_denom=denominatore(antiper,period);
 printf("\nIntero : %s",integer);
 printf("\nAntiperiodo : %s",antiper);
 printf("\nPeriodo : %s",period);
 printf("\n\nFrazione generatrice = (%d",val_tutto);// %D signed long integer
 if (atoi(period)!=0) {
                      printf("-%d)/",val_sott);
                      printf("%d = ",val_denom);
                      printf("%d",(val_tutto-val_sott));
                      printf("/%d",val_denom);
                      }
 else {
      printf(")/%d",val_denom);
      }
  puts("\n\n*   Space   *         Altro numero");
  puts("*   Altro tasto   *     Fine");
  if (getch()==' ') main(); //restart verificare su linux
  exit(0); //fine
 }

char *intero (char numero[])
{
 char temp[20];
 char *vuoto="0"; //default se scrivo es .45 senza 0 dell'int.
 strcpy(temp,numero); //char *strcpy(char *s1, const char *s2)
 temp[strcspn(temp,".")]='\0'; //tronca la str al '.'
 if (atoi(temp)==0) return (vuoto); else return(&temp);
}

char *antiperiodo (char numero[])
{
 int a=0;
 char temp[20];
 char *vuoto=" ";	//se numero non ha antiperiodo
 strcpy(temp,numero);
 while (temp[a]!='.'&& temp[a]!='\0')  a++;	//inizio antiperiodo
 temp[strcspn(temp,"(")]='\0';	//tronca la str alla '('
 if (strlen(temp)==a)  return (vuoto);	//ret.vuoto se non trova '.'
 	else return(&temp[0]+a+1);	//punt. inizio antiper in temp.
}

char *periodo (char numero[])
{
 int a=0;
 char temp[20];
 char *vuoto=" ";
 strcpy(temp,numero);
 while (temp[a]!='(' && temp[a]!='\0')  a++;	//inizio periodo
 temp[strcspn(temp,")")]='\0';	//tronca la str alla ')'
 if (strlen(temp)==a) return (vuoto); 
 	else return(&temp[0]+a+1);
}

long int denominatore (char antiper[],char period[])
{
 int len_period,len_antiper,c=0;
 char temp[20];
 len_period=strlen(period);
 len_antiper=strlen(antiper);
 if (atoi(period)!=0)	{ //numero con periodo
            			for (c=0;c<len_period;c++) temp[c]='9';//tanti '9'quanto la lungh. di period.
            			for (c=len_period;c<(len_period+len_antiper);c++) temp[c]='0';
           				}
 else {	//numero senza periodo
      temp[0]='1'; // 1cifra sicuramente =1
      if (antiper[0]!=' ') for (c=1;c<=len_antiper;c++) temp[c]='0'; //add. ZERI x len_antiper
      			else c=1;//se inserisco senza decimali taglio dopo l' 1.     
      }
 temp[c]='\0'; //taglia la str denominatore
 return atol(&temp[0]);
}
